
/*================================================*\

	Jeudi 3 decembre 1998

	Arash HABIBI

	LiaisonToolbox.c

	Quelques outils pour la couche liaison

\*================================================*/


#include "LiaisonToolbox.h"



void EncapsulerPaquet(Paquet_t paquet, int taille_paquet, Trame_t *trame , int *taille_trame)
/*================================================*\
  Telle quelle, cette fonction ne fait que ranger 
  les bits de paquet dans les bits de poids faible
  de trame. 
  La premiere version est pour le cas ou Paquet_t
  et Trame_t sont de type pointeur ou tableaux et 
  la deuxieme version est pour le cas ou ce sont
  des types simples ou des structures. 
  Si Paquet_t est de type simple et que Trame_t est
  de type pointeur ... il n'y a qu'a faire un 
  melange. Laissez parler votre creativite. 
\*================================================*/
{
  if(TYPE_POINTEUR) 
    {
      fprintf(stderr,
	"EncapsulerPaquet : la version pointeur est en commentaire.\n");
      /*memcpy(*trame, paquet, sizeof(Trame_t));
      *taille_trame = sizeof(Trame_t);*/
    }
  else				
    {				
      memcpy(trame, &paquet, sizeof(Trame_t));
      *taille_trame = sizeof(Trame_t);
    }
}


void DesEncapsulerPaquet(Trame_t trame, int taille_trame, Paquet_t *paquet, int *taille_paquet)
/*================================================*\
  Telle quelle, cette fonction ne fait que ranger 
  le paquet dans les premiers bits de la trame 
  sans rien faire d'autre. Memes remarques que 
  pour la fonction ci-dessus. 
\*================================================*/
{
  if(TYPE_POINTEUR)
    {
      fprintf(stderr,
	"DesEncapsulerPaquet : la version pointeur est en commentaire.\n");
      /*memcpy(paquet, trame, sizeof(Paquet_t));
       *taille_paquet = sizeof(Paquet_t);*/
    }
  else
    {
      memcpy(paquet, &trame, sizeof(Paquet_t));
      *taille_paquet = sizeof(Paquet_t);
    }
}

