/*===============================================*\
	Mercredi 9 Septembre 1998

	Arash HABIBI

	IPAddrByName.c

	Cette fonction sera souvent utilisee par la 
    	suite. A partir d'un nom d'hote, elle fournit
    	l'adresse IP de la machine sous la forme d'un 
    	entier long.    
\*================================================*/


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>


u_long IPAddrByName(char *Nom)
/*================================================*\
\*================================================*/
{
	u_long AdresseIP; 
	struct hostent *HostEnt; 
	
	HostEnt = gethostbyname(Nom); 
	if(HostEnt==0) {printf("Pas d'hote du nom de %s\n",Nom); exit(1);}
	
	memcpy(&AdresseIP, HostEnt->h_addr, HostEnt->h_length); 
		
	return(AdresseIP);
}

