
/*===============================================*\
	Mercredi 9 Septembre 1998

	Arash HABIBI

	RecepteurUDP.c

	Il s'agit de se choisir un numero de port
	et d'ecouter en attendant l'arrive de messages
	alors on affiche le message et on donne 
	l'identite de l'emetteur (numero IP et 
	numero de port)    
	
\*================================================*/


#include "SocketToolbox.h"


void main(int argc, char **argv)
/*================================================*\
	Une fois que la socket est attachee, elle 
	ecoute le reseau en attendant l'arrivee d'un
	message. Lorsqu'il arrive, elle en identifie
	l'emetteur et affiche le message. 
	Et ce, jusque le message recu soit 
	exclusivement limite a "."
\*================================================*/
{	
	int desc_sock, res, taille;
	u_long AdresseIP; 
	AdresseIP_t IP;   /* sous forme n1.n2.n3.n4 */
	u_short port; 
	char message[100]; 
	struct sockaddr_in adresse_loc, adresse_dist; 
	
	if(argc!=2) 
	{printf("Usage : recepteur num_port\n"); exit(1);}
	
/*-------- Creation et attachement de la socket locale ----*/
	
	desc_sock = GetAndBindSocket(SOCK_DGRAM, 
		atoi(argv[1]), &adresse_loc);
	
	printf("Recepteur ecoute sur le port numero %d\n",
		adresse_loc.sin_port);
	
/*-------- Boucle d'attente des messages ------------*/

	taille = sizeof(adresse_dist);
	
	while(strcmp(message, ".")!=0)
	{
		res = recvfrom(desc_sock,
			message, 100, 0,
			(struct sockaddr *)&adresse_dist,
			&taille);
			
		if(res==-1) {perror("recvfrom"); exit(1);}
			
		ReadNetworkAddress(adresse_dist, &IP, &port);
			
		printf("Message venant de %d.%d.%d.%d  ",
			IP.n1, IP.n2, IP.n3, IP.n4);
		printf("port numero %d ", port);
		printf("message = \"%s\" \n", message);
	}
	printf("Arret du recepteur.\n");
} 
