
/*===============================================*\
	Mercredi 9 Septembre 1998

	Arash HABIBI

	ServeurUDP_IRO.c

	Il s'agit de fournir pour les TP un 
	processus qui ecoute sur sutherland et 
	reponde aux messages en donnant la machine
	de provenance, le port d'emission et
	en rappelant le message. 

\*================================================*/


#include "SocketToolbox.h"


void main(int argc, char **argv)
/*================================================*\
\*================================================*/
{
	int desc_sock, res, taille;
	char message[100], reponse[500];
	AdresseIP_t IP;       /* avec le format n1.n2.n3.n4 */
	short port; 
	struct sockaddr_in adresse_loc, adresse_dist;
	
	if(argc!=2) 
	{printf("Usage : serveur num_port\n"); exit(1);}


/*---- Creation et attachement de la socket locale ----*/
	
	desc_sock = GetAndBindSocket(SOCK_DGRAM, atoi(argv[1]), 
		&adresse_loc);
	
	printf("Serveur ecoute sur le port numero %d\n",
		adresse_loc.sin_port);

/*----- Ecoute du reseau dans l'attente ----------------*/
/*----- de message et envoi de reponse -----------------*/

	while(1)
	{   
		res = recvfrom(desc_sock,
			message, 100, 0,
			(struct sockaddr *)&adresse_dist,
			&taille);

		/*if(res==-1) {perror("recvfrom");}*/
		
/*------ Preparation de la reponse ------------------------------*/
		
		ReadNetworkAddress(adresse_dist, &IP, &port);

		sprintf(reponse, 
	 " Bonjour! ici le laboratoire d'infographie \
	\n    de l'Universite de Montreal au Canada. \
        \n Votre message :   \
        \n \"%s\" \
	\n venant de l'hote %d.%d.%d.%d et du port numero %d \
	\n sera transmis a Arash Habibi (ancien post-doc ici).\
	\n Ciao !", message, IP.n1, IP.n2, IP.n3, IP.n4, port);
	
/*---------- Envoi de la reponse ------------------------------*/
	
		res=sendto(desc_sock, 
			   reponse, 
			   strlen(reponse)+1, 0, 
			   (struct sockaddr *)&adresse_dist, 
			   sizeof(adresse_dist));
		/*if(res==-1) {perror("sendto");}*/
	}
}
		
