
/*===============================================*\
	Mardi 3 novembre 1998

	Arash HABIBI

	Logic.h

	Quelques fonctions logiques comme les 
	ou exclusifs. 

\*================================================*/


#ifndef _LOGIC_H
#define _LOGIC_H


#define MAX_MESSAGE 50


typedef short CarCode_t;	/* Caractere code' */

char NiemeBit(int nombre, int n); 
void CheckBitABit(CarCode_t cc, char *comment);

void SetNiemeBitCC(CarCode_t *nombre, int n, int value);
void SetNiemeBitC(char *nombre, int n, int value);

CarCode_t OuExclusif(CarCode_t a, CarCode_t b);
void ChangeNiemeBitCC(CarCode_t *cc, int n);
void ChangeNiemeBitC(char *c, int n);

void TronquerANbits(CarCode_t *cc, int N);

int Degre(CarCode_t cc);

CarCode_t ResteDivisionModulo2(CarCode_t dividende, CarCode_t diviseur);

#endif
