
/*===============================================*\
	Mercredi 9 Septembre 1998

	Arash HABIBI

	UnixDgrmRecepteur.c

	Le programme est identique a BindUnix.c
	dans sa premiere partie. Le programme doit
	etre lance avec l'adresse de la socket locale.
	Ensuite, avec la primitive recvfrom, il 
	ecoute le silence du systeme (!) Des qu'il 
	recoit un message il en affiche le contenu
	et donne l'adresse de la socket emettrice.     
	
\*================================================*/


#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>

struct sockaddr_un adresse_loc, adresse_dist;

void main(int argc, char **argv)
/*================================================*\
\*================================================*/
{
	struct sockaddr_un *adrloc_p, *adrdist_p; 
	int desc, res, adr_pt; 
	char message[100];	
	
	if(argc!=2) {printf("Usage : recepteur socket_loc\n"); 
			exit(1);}

/* ----- creation de la socket ----- */

	desc = socket(AF_UNIX, SOCK_DGRAM, 0);

	if(desc == -1) {perror("socket"); exit(1);}
	else printf("Socket de reception creee.\n");
		
	
/* ----- preparation de l'adresse locale ----- */

	adrloc_p = &adresse_loc;
	adrloc_p->sun_family = AF_UNIX; 
	strcpy(adrloc_p->sun_path, argv[1]);

/* ----- et attachement de la socket a   ----- */
/* ----- l'adresse par bind              ----- */		
	
	res = bind(desc, (struct sockaddr *)adrloc_p,
		 sizeof(adresse_loc));

	if(res == -1) {perror("bind"); exit(1);}
	else printf("Socket de reception attachee.\n");

	
/*--------- Nouveau par rapport a BindUnix.c -------------------*/
	
	adrdist_p = &adresse_dist; 
	adr_pt = sizeof(adresse_dist); 
	
/* ----- Attente de la reception d'un message ------ */

	res = recvfrom(desc, message, 
		500, 0, 
		(struct sockaddr *)adrdist_p,
		&adr_pt);

	if(res==-1) {perror("recvfrom recepteur"); exit(1);}
	else printf("Recepteur : message recu de la part de %s :\"%s\"\n",
		adresse_dist.sun_path, message);
}	 
